import javax.microedition.io.file.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.Enumeration;

public class Lib_filesystem {

    public static DataInputStream   in_stream[];
    public static DataOutputStream  out_stream[];
    public static FileConnection    fc_list[];
    public static boolean           open[];
    public static int               offsets[];

    public static void fstart() {        
        fc_list     = new FileConnection[8];
        in_stream   = new DataInputStream[8];
        out_stream  = new DataOutputStream[8];
        open        = new boolean[8];
        offsets     = new int[8];
        
        for(int i = 0; i < 8; i++) {
            open[i]         = false;
            fc_list[i]      = null;
            in_stream[i]    = null;
            out_stream[i]   = null;
            offsets[i]      = 0;
        }            
    }
    
    public static int fopen( String path ) {
        int handle = -1;
        for( int i = 0; i < 8; i++ ) {
            if( !open[i] ) {
                handle = i;
                break;
            }
        }
        if ( handle != -1 ) {            
            try {
                fc_list[handle]     = (FileConnection) Connector.open( "file://" + path );                
                if( !fc_list[handle].exists() )  {
                    fc_list[handle].create();
                }
                open[handle] = true;
                offsets[handle] = 0;
                return handle;
            }
            catch ( IOException ex ) {
                return -1;
            }            
        }
        return -1;        
    }
    
    public static void fclose( int handle ) {
        try {
            if ( open[handle] ) {               
                if ( in_stream[handle] != null ) {
                    in_stream[handle].close();
                }                
                if ( out_stream[handle] != null ) {
                    out_stream[handle].close();
                }                
                //if( fc_list[handle].isOpen() ) {
                    fc_list[handle].close();
                //}
                open[handle] = false;
                offsets[handle] = 0;
            }
        }
        catch ( Exception ex ) {
            System.out.println( ex.toString() );
        }
    }
    
    public static void fwrite( int handle, String data ) throws IOException {
        if ( out_stream[handle] == null ) {
            out_stream[handle] = fc_list[handle].openDataOutputStream();
        }
        byte[] buffer = data.getBytes();
        out_stream[handle].write( buffer, 0, buffer.length );
    }
    
    public static void fwrite_byte( int handle, int data ) throws IOException {    
        if( out_stream[handle] == null ) {
            out_stream[handle] = fc_list[handle].openDataOutputStream();
        }
        out_stream[handle].writeByte( data );
    }
    
    public static String fread( int handle, int length ) {     
        StringBuffer result = new StringBuffer();
        try {
            byte[] d = new byte[length];
            if ( in_stream[handle] == null ) {
                in_stream[handle]   = fc_list[handle].openDataInputStream();
            }
            in_stream[handle].read( d, 0, length );
            //offsets[handle] += length;
            for( int i = 0; i < length; i++ ) {
                byte b = d[i];
                result.append( (char)b );
            }
        }
        catch ( Exception e ) {
            System.out.println( e.toString() );
            return "";
        }
        return result.toString();
    }
    
    public static int fread_byte( int handle ) throws IOException {    
        if( in_stream[handle] == null ) {
            in_stream[handle] = fc_list[handle].openDataInputStream();
        }
        return in_stream[handle].read();
    }
    
    public static String fgets( int handle ) throws IOException {
        if( in_stream[handle] == null ) {
            in_stream[handle] = fc_list[handle].openDataInputStream();
        }
        StringBuffer buffer = new StringBuffer();
        int ch = 0;
        while( ( ( ch = in_stream[handle].read() ) != '\n' ) && ( in_stream[handle].available() > 0 ) ) {
            buffer.append( (char)ch );
        }
        return buffer.toString();
    }
    
    public static int feof( int handle ) throws IOException {
        
        if ( in_stream[handle] == null ) {
                in_stream[handle]   = fc_list[handle].openDataInputStream();
        }
        
        if ( in_stream[handle].available() == 0 ) {
            return 1;
        } else {
            return 0;
        }        
    }
    
    public static void fseek( int handle, int offset ) throws IOException {
        if ( in_stream[handle] == null ) {
                in_stream[handle]   = fc_list[handle].openDataInputStream();
                in_stream[handle].skip( offset );
        }
        offsets[handle] = offset;
    }
    
    public static void freset( int handle ) throws IOException {
        if ( in_stream[handle] == null ) {
                in_stream[handle]   = fc_list[handle].openDataInputStream();
                in_stream[handle].reset();
        }
    }
    
    public static void fflush( int handle ) throws IOException {
        if ( out_stream[handle] == null ) {
            out_stream[handle] = fc_list[handle].openDataOutputStream();
        }
        out_stream[handle].flush();
    }
    
    public static String file_get_contents( String filename ) {
        StringBuffer s = new StringBuffer();
        try {
            FileConnection fs = (FileConnection)Connector.open( "file://" + filename );
            if ( !fs.exists() ) {
                return "";
            }
            int size = (int)fs.fileSize();
            byte[] d = new byte[size];
            DataInputStream is = fs.openDataInputStream();
            is.read(d, 0, size);
            for(int i=0;i<size;i++){
                byte b= d[i];
                s.append((char)(b < 0 ? b == -88 ? 0x401 : b == -72 ? 0x451 : (0x400 | ((b & 0x7f) - 0x30)) : b));
            }
        }
        catch ( Exception e ) {
            return "";
        }
        return s.toString();
    }
    
    public static void file_put_contents( String name, String info ) {
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+name);
            if (!fs.exists())fs.create();
            DataOutputStream os = fs.openDataOutputStream();
            byte[] d = new byte[info.length()];
            for(int i=0;i<d.length;i++){
                char b =  info.charAt(i);
                if ( b > 255 ) {
                    d[i] = (byte)(b-848);
                } else {
                    d[i] = (byte)b;
                }
            }
            os.write(d,0,d.length);
            os.flush();
            os.close();
        }
        catch ( Exception e ) {
            return;
        }
    }
    
    public static int file_exists(String name) {
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+name);
            if( fs.exists() ) {
                return 1;
            }
        }
        catch ( Exception e ) {
            return 0;
        }
        return 0;
    }
    
    public static String get_dirs(String path) {
        StringBuffer s = new StringBuffer();
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+path);
            Enumeration r = fs.list();
            fs.close();
            while(r.hasMoreElements()) {
                String t = (String)r.nextElement();
                if ( t.endsWith("/") ) {
                   s.append(t).append('|');
                }
            }
        }
        catch ( Exception e ) {
            return "";
        }
        return s.toString();
    }
    
    public static String get_files(String path) {
        StringBuffer s = new StringBuffer();
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+path);
            Enumeration r = fs.list();
            fs.close();
            while(r.hasMoreElements()) {
                String t = (String)r.nextElement();
                if ( !t.endsWith("/") ) {
                   s.append(t).append('|');
                }
            }
        }   
        catch ( Exception e ) {
            return "";
        }
        return s.toString();
    }
    
    public static String get_roots() {
        StringBuffer s = new StringBuffer();
        try {
            Enumeration r  = FileSystemRegistry.listRoots();
            while ( r.hasMoreElements() ) {
                s.append((String) r.nextElement()).append('|');
            }
        }
        catch ( Exception e ) {
            return "";
        }
        return s.toString();
    }
    
    public static String get_path(String name) {
        String result = "";
        try{
            FileConnection fs = (FileConnection)Connector.open("file://"+name);
            result=fs.getPath();
        }
        catch(Exception e) {result="";}
        return result;
    }

    public static String get_name(String name) {
        String result = "";
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+name);
            result=fs.getName();
        }
        catch ( Exception e ) {
            result = "";
        }
        return result;
    }
    
    public static void delete_file(String name) {
        try {
            FileConnection fs = (FileConnection)Connector.open("file://"+name);
            fs.delete();
        }
        catch ( Exception e ) {
            return;
        }
    }
    
    public static int mkdir(String target) {
        try {
            FileConnection fs = (FileConnection)Connector.open( "file://" + target );
            if ( !fs.exists() ) {
                fs.mkdir();
                return 1;
            }
        }
        catch ( IOException ex ) {
        }
        return 0;
    }
    
    public static int rename( String old, String target ) {
        try {
            FileConnection fs = (FileConnection)Connector.open( "file://" + old );
            if( fs.exists() ) {
                fs.rename(target);
                return 1;
            }
        }
        catch ( IOException ex ) {
        }
        return 0;
    }
    
    public static int file_size( String filename ) {
        try {
            long size = 0;
            FileConnection fs = (FileConnection)Connector.open( "file://" + filename );
            if( fs.exists() ) {
                size = fs.fileSize();
            }
            fs.close();
            return (int)size;
        }
        catch ( IOException ex ) {
        }
        return 0;
    }
    
}
